// Generated by CoffeeScript 1.12.7
(function() {
  var ExpressHandler, OctobluRaven, Raven, _, debug,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  _ = require('lodash');

  Raven = require('raven');

  ExpressHandler = require('./express-handler');

  debug = require('debug')('octoblu-raven:index');

  OctobluRaven = (function() {
    function OctobluRaven(arg) {
      var ref;
      ref = arg != null ? arg : {}, this.dsn = ref.dsn, this.logFn = ref.logFn;
      this.off = bind(this.off, this);
      this.patchGlobal = bind(this.patchGlobal, this);
      this.reportError = bind(this.reportError, this);
      this.handleExpress = bind(this.handleExpress, this);
      if (this.logFn == null) {
        this.logFn = console.error;
      }
      if (this.dsn == null) {
        this.dsn = process.env.SENTRY_DSN;
      }
      debug('constructed with', {
        dsn: this.dsn
      });
      if (Raven.installed) {
        return;
      }
      Raven.disableConsoleAlerts();
      if (this.dsn != null) {
        Raven.config(this.dsn).install();
      }
    }

    OctobluRaven.prototype.handleExpress = function(arg) {
      var app, expressHandler;
      app = arg.app;
      if (app == null) {
        throw new Error('OctobluRaven->express requires app');
      }
      expressHandler = new ExpressHandler({
        dsn: this.dsn,
        logFn: this.logFn
      });
      app.use(expressHandler.requestHandler());
      app.use(expressHandler.errorHandler());
      return app.use(expressHandler.sendErrorHandler());
    };

    OctobluRaven.prototype.reportError = function(error, extra) {
      if (this.dsn == null) {
        return this.logFn(error, extra);
      }
      if (_.isError(error)) {
        return Raven.captureException(error, extra);
      }
      if (_.isString(error)) {
        return Raven.captureMessage(error, extra);
      }
      return Raven.captureMessage(JSON.stringify(error), extra);
    };

    OctobluRaven.prototype.patchGlobal = function() {
      if (this.dsn == null) {
        return;
      }
      Raven.uninstall();
      return Raven.install((function(_this) {
        return function(error) {
          var ref, ref1;
          _this.logFn((ref = (ref1 = error != null ? error.stack : void 0) != null ? ref1 : error != null ? error.message : void 0) != null ? ref : error);
          return process.exit(1);
        };
      })(this));
    };

    OctobluRaven.prototype.off = function() {
      return Raven.uninstall();
    };

    return OctobluRaven;

  })();

  module.exports = OctobluRaven;

}).call(this);

//# sourceMappingURL=index.js.map
